Subject: bug#32018: Guixsd pull error on very old install

From: [email-masked] (Ludovic Courtès)
Date: Fri, 13 Jul 2018 22:42:54 +0200

Pjotr Prins <[email-masked]> skribis:

> On Mon, Jul 02, 2018 at 11:39:40AM +0200, Ludovic Courtès wrote:
>> Hello,
>> 
>> swedebugia <[email-masked]> skribis:
>> 
>> > Trying to get an updated an old GuixSD installation via guix pull on a pre 0.10 GuixSD returned an error message about gexp-modules not found. (details can be provided if asked). 
>> 
>> Could you post the full backtrace?
>> 
>> > I suggest we either test pulling from old versions (and fix errors) or make it clear in the manual that pulling from very old GuixSD (older than 0.12?) is not supported.
>> 
>> Pulling from a very old Guix may not work.  We try hard to keep things
>> running, but the old ‘guix pull’ had defects, plus the file
>> build-aux/build-self.scm (which ‘guix pull’ runs) might use features not
>> found in very old versions.
>
> How about making sure that 'guix pull' works between major releases?
> That should be reasonably easy to test.
>
> When there is a disruptive release for guix pull make sure the user
> upgrades to the closest previous release first. I.e., multi-step
> releases are less fraught with breakage.
>
> That way you get an incremental path to upgrade. And you only need to
> test between major releases.

I agree, yes.  That’s a reasonable goal and one that should be easier to
achieve now with the new ‘guix pull’.

Note that swedebugia was talking of a pre-0.10 GuixSD, more than 2.5
years old, which represents a looong time for a pre-1.0 piece of
software that evolves pretty fast.  :-)

Thank you,
Ludo’.